
local PoleFlag = ...

-- Register common prefab nodes
PoleFlag:registerAssetId("models/poleFlag.fbx/Prefab/poleFlag/Pole/step_0_RootPart", "POLE_FLAG_ROOT_PREFAB")
PoleFlag:registerAssetId("models/poleFlag.fbx/Prefab/poleFlag/Pole/step_3_TopPart", "POLE_FLAG_TOP_PREFAB")
PoleFlag:registerAssetId("models/poleFlag.fbx/Prefab/poleFlag/Pole/step_2_Tiling2Part", "POLE_FLAG_TILING2_PREFAB")
PoleFlag:registerAssetId("models/poleFlag.fbx/Prefab/poleFlag/Pole/step_1_Tiling3Part", "POLE_FLAG_TILING3_PREFAB")
--------------------------------------------------------------------------

-- Create default building part registering function 
function registerDefaultBuildingPart(_nodePrefix)
	PoleFlag:register({
		DataType = "BUILDING_PART",
		Id = _nodePrefix .. "_PART",
		Mover = { DataType = "BUILDING_PART_MOVER" },
		ConstructorData = { DataType = "BUILDING_CONSTRUCTOR_DEFAULT", CoreObjectPrefab = _nodePrefix .. "_PREFAB" }
	})
end

local defaultNodePrefixList = {
	"POLE_FLAG_TOP",
	"POLE_FLAG_TILING2",
	"POLE_FLAG_TILING3"
}

-- Register simple building part assets
for i, nodePrefix in ipairs(defaultNodePrefixList) do
	registerDefaultBuildingPart(nodePrefix)
end

--------------------------------------------------------------------------

-- Register the stone gate set decoration flag part
PoleFlag:register({
	DataType = "BUILDING_PART",
	Id = "POLE_FLAG_ROOT_PART",
	Name = "POLE_FLAG_ROOT_NAME",
	Description = "POLE_FLAG_ROOT_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = "POLE_FLAG_ROOT_PREFAB",
		EndPart = "POLE_FLAG_TOP_PART",
		FillerList = {
			"POLE_FLAG_TILING2_PART"
                },
		BasementFillerList = {
			"POLE_FLAG_TILING3_PART"
         	},
		MinimumScale = 0,
		BasementScale = 1,
		IsVertical = true
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 2 },
			{ Resource = "WOOLEN_CLOTH", Quantity = 2 }

		}
	}
})
-- Override building part components properties (generated by the building asset processor) to add building zones

PoleFlag:registerPrefabComponent("models/poleFlag.fbx/Prefab/poleFlag/Pole/step_0_RootPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 1, 1 }
})
